﻿//=================================================================
//
//				      Rarekiller - Plugin
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.IO;
using System.Xml;
using System.Windows.Forms;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;

namespace katzerle
{
    public partial class RarekillerUI : Form
    {
        public static LocalPlayer Me = StyxWoW.Me;

        public RarekillerUI()
        {
            InitializeComponent();

            // Rarekiller
            CBHuntByID.Checked = Rarekiller.Settings.HUNTbyID;
            TBHuntByID.Text = Rarekiller.Settings.MobID;
            TBHuntByID.Enabled = CBHuntByID.Checked;
            CBKillTagged.Checked = Rarekiller.Settings.KillTagged;
            // Pull Spell
            CBPull.Checked = Rarekiller.Settings.DefaultPull;
            CBPull2.Checked = !Rarekiller.Settings.DefaultPull;
            TBPull.Text = Rarekiller.Settings.Pull;
            TBPull.Enabled = CBPull2.Checked;
            CBForceRange.Checked = Rarekiller.Settings.ForceRange;
            TBRange.Text = Rarekiller.Settings.Range;
            TBRange.Enabled = CBForceRange.Checked;
            // Special Rares
            CBCamel.Checked = Rarekiller.Settings.Camel;
            CBAeonaxx.Checked = Rarekiller.Settings.Aeonaxx;
            CBVoidtalon.Checked = Rarekiller.Settings.Voidtalon;
            // Tamer
            CBTameByID.Checked = Rarekiller.Settings.TameByID;
            CBNotKillTameable.Checked = Rarekiller.Settings.NotKillTameable;
            TBTameID.Text = Rarekiller.Settings.TameMobID;
            CBTameByID.Enabled = Rarekiller.Settings.Hunteractivated;
            TBTameID.Enabled = Rarekiller.Settings.Hunteractivated && CBTameByID.Checked;
            // Configurable XMLs
            CBKillList.Checked = Rarekiller.Settings.KillList;
            CBInteractNPC.Checked = Rarekiller.Settings.InteractNPC;
            CBObjects.Checked = Rarekiller.Settings.ObjectsCollector;
            CBTameList.Checked = Rarekiller.Settings.TameList;
            CBTameList.Enabled = Rarekiller.Settings.Hunteractivated;
            // General Settings
            TBBlacklistTime.Text = Rarekiller.Settings.BlacklistTime;
            TBBlacklistEnd.Text = Rarekiller.Settings.BlacklistEnd;
            CBKeyer.Checked = Rarekiller.Settings.Keyer;
            // Alerts
            CBLUAoutput.Checked = Rarekiller.Settings.LUAoutput;
            CBAlert.Checked = Rarekiller.Settings.Alert;
            CBWisper.Checked = Rarekiller.Settings.Wisper;
            CBBNWisper.Checked = Rarekiller.Settings.BNWisper;
            CBGuild.Checked = Rarekiller.Settings.Guild;
            TBSoundfileWisper.Text = Rarekiller.Settings.SoundfileWisper;
            TBSoundfileGuild.Text = Rarekiller.Settings.SoundfileGuild;
            TBSoundfileFoundRare.Text = Rarekiller.Settings.SoundfileFoundRare;
        }

        private void BSave_Click(object sender, EventArgs e)
        {
            // Rarekiller
            Rarekiller.Settings.HUNTbyID = CBHuntByID.Checked;
            Rarekiller.Settings.MobID = TBHuntByID.Text;
            Rarekiller.Settings.KillTagged = CBKillTagged.Checked;
            // Pull Spell
            Rarekiller.Settings.DefaultPull = CBPull.Checked;
            Rarekiller.Settings.Pull = TBPull.Text;
            Rarekiller.Settings.ForceRange = CBForceRange.Checked;
            Rarekiller.Settings.Range = TBRange.Text;
            // Special Rares
            Rarekiller.Settings.Camel = CBCamel.Checked;
            Rarekiller.Settings.Aeonaxx = CBAeonaxx.Checked;
            Rarekiller.Settings.Voidtalon = CBVoidtalon.Checked;
            // Tamer
            Rarekiller.Settings.TameByID = CBTameByID.Checked;
            Rarekiller.Settings.NotKillTameable = CBNotKillTameable.Checked;
            Rarekiller.Settings.TameMobID = TBTameID.Text;
            // Configurable XMLs
            Rarekiller.Settings.KillList = CBKillList.Checked;
            Rarekiller.Settings.InteractNPC = CBInteractNPC.Checked;
            Rarekiller.Settings.ObjectsCollector = CBObjects.Checked;
            Rarekiller.Settings.TameList = CBTameList.Checked;
            // General Settings
            Rarekiller.Settings.BlacklistTime = TBBlacklistTime.Text;
            Rarekiller.Settings.BlacklistEnd = TBBlacklistEnd.Text;
            Rarekiller.Settings.Keyer = CBKeyer.Checked;
            // Alerts
            Rarekiller.Settings.LUAoutput = CBLUAoutput.Checked;
            Rarekiller.Settings.Alert = CBAlert.Checked;
            Rarekiller.Settings.Wisper = CBWisper.Checked;
            Rarekiller.Settings.BNWisper = CBBNWisper.Checked;
            Rarekiller.Settings.Guild = CBGuild.Checked;
            Rarekiller.Settings.SoundfileWisper = TBSoundfileWisper.Text;
            Rarekiller.Settings.SoundfileGuild = TBSoundfileGuild.Text;
            Rarekiller.Settings.SoundfileFoundRare = TBSoundfileFoundRare.Text;

            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller Settings Saved");

            // Save XML
            XmlDocument xml;
            XmlElement root;
            XmlElement element;
            XmlText text;
            XmlComment xmlComment;

            string sPath = Rarekiller.SettingsPath;

            if (!Directory.Exists(sPath))
            {
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Creating config directory");
                Directory.CreateDirectory(sPath);
            }

            sPath = Path.Combine(sPath, StyxWoW.Me.RealmName, StyxWoW.Me.Name, "Rarekiller.config");

            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Saving config file");
            Logging.Write(Colors.MediumPurple, "Rarekiller: Settings Saved");
            xml = new XmlDocument();
            XmlDeclaration dc = xml.CreateXmlDeclaration("1.0", "utf-8", null);
            xml.AppendChild(dc);

            xmlComment = xml.CreateComment(
                "=======================================================================\n" +
                ".CONFIG  -  This is the Config File For Rarekiller\n" +
                "========================================================================");

            //let's add the root element
            root = xml.CreateElement("Rarekiller");
            root.AppendChild(xmlComment);

            //let's add another element (child of the root)
            element = xml.CreateElement("HuntByID");
            text = xml.CreateTextNode(CBHuntByID.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("MobID");
            text = xml.CreateTextNode(TBHuntByID.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("KillTagged");
            text = xml.CreateTextNode(CBKillTagged.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("DefaultPull");
            text = xml.CreateTextNode(CBPull.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Pull");
            text = xml.CreateTextNode(TBPull.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("ForceRange");
            text = xml.CreateTextNode(CBForceRange.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Range");
            text = xml.CreateTextNode(TBRange.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Aeonaxx");
            text = xml.CreateTextNode(CBAeonaxx.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Camel");
            text = xml.CreateTextNode(CBCamel.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Voidtalon");
            text = xml.CreateTextNode(CBVoidtalon.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("NotKillTameable");
            text = xml.CreateTextNode(CBNotKillTameable.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("TameByID");
            text = xml.CreateTextNode(CBTameByID.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("TameMobID");
            text = xml.CreateTextNode(TBTameID.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("KillList");
            text = xml.CreateTextNode(CBKillList.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("ObjectsCollector");
            text = xml.CreateTextNode(CBObjects.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("InteractNPC");
            text = xml.CreateTextNode(CBInteractNPC.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("TameList");
            text = xml.CreateTextNode(CBTameList.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Keyer");
            text = xml.CreateTextNode(CBKeyer.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("BlacklistTime");
            text = xml.CreateTextNode(TBBlacklistTime.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("BlacklistEnd");
            text = xml.CreateTextNode(TBBlacklistEnd.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("LUAoutput");
            text = xml.CreateTextNode(CBLUAoutput.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Alert");
            text = xml.CreateTextNode(CBAlert.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Wisper");
            text = xml.CreateTextNode(CBWisper.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("BNWisper");
            text = xml.CreateTextNode(CBBNWisper.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("GuildChat");
            text = xml.CreateTextNode(CBGuild.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("SoundfileFoundRare");
            text = xml.CreateTextNode(TBSoundfileFoundRare.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("SoundfileWisper");
            text = xml.CreateTextNode(TBSoundfileWisper.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("SoundfileGuild");
            text = xml.CreateTextNode(TBSoundfileGuild.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            xml.AppendChild(root);

            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.Create,
                                                               System.IO.FileAccess.Write);
            try
            {
                xml.Save(fs);
                fs.Close();
            }
            catch (Exception np)
            {
                Logging.WriteDiagnostic(Colors.Red, np.Message);
            }

            Close();
        }

        private void BSoundfileFoundRare_Click(object sender, EventArgs e)
        {
            string sPath = Path.Combine(Rarekiller.FolderPath, "Sounds\\");

            var loadSoundfileFoundRare = new OpenFileDialog
            {
                Filter = "WAVE File (*.wav)|*.wav|WAVE File (*.wave)|*.wave",
                Title = "Select wav file to load",
                InitialDirectory = sPath
            };

            if (loadSoundfileFoundRare.ShowDialog() == DialogResult.OK)
            {
                string fileName1 = loadSoundfileFoundRare.FileName;
                if (!string.IsNullOrEmpty(fileName1))
                {
                    TBSoundfileFoundRare.Text = fileName1;
                }
            }
        }

        private void BSoundfileWisper_Click(object sender, EventArgs e)
        {
            string sPath = Path.Combine(Rarekiller.FolderPath, "Sounds\\");

            var loadSoundfileWisper = new OpenFileDialog
            {
                Filter = "WAVE File (*.wav)|*.wav|WAVE File (*.wave)|*.wave",
                Title = "Select wav file to load",
                InitialDirectory = sPath
            };

            if (loadSoundfileWisper.ShowDialog() == DialogResult.OK)
            {
                string fileName2 = loadSoundfileWisper.FileName;
                if (!string.IsNullOrEmpty(fileName2))
                {
                    TBSoundfileWisper.Text = fileName2;
                }
            }
        }

        private void BSoundfileGuild_Click(object sender, EventArgs e)
        {
            string sPath = Path.Combine(Rarekiller.FolderPath, "Sounds\\");

            var loadSoundfileGuild = new OpenFileDialog
            {
                Filter = "WAVE File (*.wav)|*.wav|WAVE File (*.wave)|*.wave",
                Title = "Select wav file to load",
                InitialDirectory = sPath
            };

            if (loadSoundfileGuild.ShowDialog() == DialogResult.OK)
            {
                string fileName3 = loadSoundfileGuild.FileName;
                if (!string.IsNullOrEmpty(fileName3))
                {
                    TBSoundfileGuild.Text = fileName3;
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Rarekiller
            CBHuntByID.Checked = false;
            TBHuntByID.Text = "";
            TBHuntByID.Enabled = false;
            CBKillTagged.Checked = false;
            // Pull Spell
            CBPull.Checked = true;
            CBPull2.Checked = false;
            TBPull.Text = "";
            TBPull.Enabled = false;
            CBForceRange.Checked = false;
            TBRange.Text = "";
            TBRange.Enabled = false;
            // Special Rares
            CBCamel.Checked = false;
            CBAeonaxx.Checked = false;
            CBVoidtalon.Checked = false;
            // Tamer
            CBTameByID.Checked = false;
            CBNotKillTameable.Checked = false;
            TBTameID.Text = "";
            CBTameByID.Enabled = Rarekiller.Settings.Hunteractivated;
            TBTameID.Enabled = false;
            // Configurable XMLs
            CBKillList.Checked = true;
            CBInteractNPC.Checked = true;
            CBObjects.Checked = true;
            CBTameList.Checked = false;
            CBTameList.Enabled = Rarekiller.Settings.Hunteractivated;
            // General Settings
            TBBlacklistTime.Text = "180";
            TBBlacklistEnd.Text = "300";
            CBKeyer.Checked = true;
            // Alerts
            CBAlert.Checked = true;
            CBLUAoutput.Checked = false;
            CBWisper.Checked = true;
            CBBNWisper.Checked = true;
            CBGuild.Checked = false;
            TBSoundfileWisper.Text = Rarekiller.Soundfile2;
            TBSoundfileGuild.Text = Rarekiller.Soundfile2;
            TBSoundfileFoundRare.Text = Rarekiller.Soundfile;

            // Rarekiller
            Rarekiller.Settings.HUNTbyID = CBHuntByID.Checked;
            Rarekiller.Settings.MobID = TBHuntByID.Text;
            Rarekiller.Settings.KillTagged = CBKillTagged.Checked;
            // Pull Spell
            Rarekiller.Settings.DefaultPull = CBPull.Checked;
            Rarekiller.Settings.Pull = TBPull.Text;
            Rarekiller.Settings.Range = TBRange.Text;
            // Special Rares
            Rarekiller.Settings.Camel = CBCamel.Checked;
            Rarekiller.Settings.Aeonaxx = CBAeonaxx.Checked;
            Rarekiller.Settings.Voidtalon = CBVoidtalon.Checked;
            // Tamer
            Rarekiller.Settings.TameByID = CBTameByID.Checked;
            Rarekiller.Settings.NotKillTameable = CBNotKillTameable.Checked;
            Rarekiller.Settings.TameMobID = TBTameID.Text;
            // Configurable XMLs
            Rarekiller.Settings.KillList = CBKillList.Checked;
            Rarekiller.Settings.InteractNPC = CBInteractNPC.Checked;
            Rarekiller.Settings.ObjectsCollector = CBObjects.Checked;
            Rarekiller.Settings.TameList = CBTameList.Checked;
            // General Settings
            Rarekiller.Settings.BlacklistTime = TBBlacklistTime.Text;
            Rarekiller.Settings.BlacklistEnd = TBBlacklistEnd.Text;
            Rarekiller.Settings.Keyer = CBKeyer.Checked;
            //Alerts
            Rarekiller.Settings.LUAoutput = CBLUAoutput.Checked;
            Rarekiller.Settings.Alert = CBAlert.Checked;
            Rarekiller.Settings.Wisper = CBWisper.Checked;
            Rarekiller.Settings.BNWisper = CBBNWisper.Checked;
            Rarekiller.Settings.Guild = CBGuild.Checked;
            Rarekiller.Settings.SoundfileWisper = TBSoundfileWisper.Text;
            Rarekiller.Settings.SoundfileGuild = TBSoundfileGuild.Text;
            Rarekiller.Settings.SoundfileFoundRare = TBSoundfileFoundRare.Text;
        }

        private void CBHuntByID_CheckedChanged(object sender, EventArgs e)
        {
            if (CBHuntByID.Checked)
            {
                TBHuntByID.Enabled = true;
                TBHuntByID.Text = Rarekiller.Settings.MobID;
            }
            else
            {
                TBHuntByID.Enabled = false;
                TBHuntByID.Text = "";
            }
        }

        private void CBPull_CheckedChanged(object sender, EventArgs e)
        {
            if (!CBPull.Checked)
            {
                CBPull2.Checked = true;
                TBPull.Enabled = true;
                TBPull.Text = Rarekiller.Settings.Pull;
            }
            else
            {
                CBPull2.Checked = false;
                TBPull.Text = "";
                TBPull.Enabled = false;
            }
        }

        private void CBTameByID_CheckedChanged(object sender, EventArgs e)
        {
            if (CBTameByID.Checked)
            {
                TBTameID.Enabled = true;
                TBTameID.Text = Rarekiller.Settings.TameMobID;
            }
            else
            {
                TBTameID.Enabled = false;
                TBTameID.Text = "";
            }
        }

        private void CBForceRange_CheckedChanged(object sender, EventArgs e)
        {
            if (CBForceRange.Checked)
            {
                TBRange.Enabled = true;
                TBRange.Text = Rarekiller.Settings.Range;
            }
            else
            {
                TBRange.Enabled = false;
                TBRange.Text = "";
            }
        }
    }
}
