﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;

namespace katzerle
{
    class RarekillerAeonaxx
    {
        /// <summary>
        /// returns the WoWUnit Aeonaxx Friendly ID 50062
        /// </summary>
        public WoWUnit AeonaxxFriendly
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => !Blacklist.Contains(u.Guid, Rarekiller.Settings.Flags) && (u.Entry == 50062)).OrderBy(u => u.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// returns the WoWUnit Aeonaxx Hostile ID 51236
        /// </summary>
        public WoWUnit AeonaxxHostile
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => !Blacklist.Contains(u.Guid, Rarekiller.Settings.Flags) && (u.Entry == 51236)).OrderBy(u => u.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// returns the WoWUnit young Stone Drake ID 44038
        /// </summary>
        public WoWUnit YoungStoneDrake
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => !Blacklist.Contains(u.Guid, Rarekiller.Settings.Flags) && (u.Entry == 44038)).OrderBy(u => u.Distance).FirstOrDefault();
            }
        }

        public static LocalPlayer Me = StyxWoW.Me;
        private static Stopwatch BlacklistTimer = new Stopwatch();

        /// <summary>
        /// Function to Find and Interact with NPCs
        /// </summary>
        public void catchAeonaxx()
        {      
            if (AeonaxxFriendly != null && AeonaxxFriendly.IsAlive && AeonaxxHostile == null && !StyxWoW.Me.Combat)
            {
                if (Rarekiller.Settings.Alert)
                    Rarekiller.Alert();

                Logging.Write(Colors.MediumPurple, "Rarekiller: Aeonaxx is valid, we're not in combat and aeonaxx is alive. Moving to Aeonaxx at" + " X: " + AeonaxxFriendly.Location.X + " Y: " + AeonaxxFriendly.Location.Y + " Z: " + AeonaxxFriendly.Location.Z);

                while (AeonaxxFriendly.Location.Distance(Me.Location) > 3 && AeonaxxFriendly != null && AeonaxxHostile == null)
                {                  
                    Flightor.MoveTo(AeonaxxFriendly.Location);
                    AeonaxxFriendly.Interact();
                    Thread.Sleep(200);
                }
            }            
            else if (AeonaxxHostile != null && AeonaxxHostile.IsAlive)
            {
                if (AeonaxxHostile.TaggedByOther)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Aeonaxx is tagged by someone else");
                }
                else
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: [Mounted] attacking Aeonaxx");
                }

                AeonaxxHostile.Target();
                Thread.Sleep(500);

                if (!Rarekiller.Settings.DefaultPull && SpellManager.HasSpell(Rarekiller.Settings.Pull))
                {
                    RarekillerSpells.CastSafe(Rarekiller.Settings.Pull, AeonaxxHostile, true);
                }
                else
                {
                    RarekillerSpells.CastSafe(Rarekiller.Spells.DefaultPullspell, AeonaxxHostile, true);
                }

                Thread.Sleep(500);
            }
            else if (AeonaxxFriendly != null && !AeonaxxFriendly.IsAlive)
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: Aeonaxx is dead");

                while (Me.IsFalling)
                {
                    Thread.Sleep(1000);
                }

                if (AeonaxxFriendly.CanLoot)
                {
                    Rarekiller.Loothelper(AeonaxxFriendly);
                }

                if (!Blacklist.Contains(AeonaxxFriendly.Guid, Rarekiller.Settings.Flags))
                {
                    Blacklist.Add(AeonaxxFriendly.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                }
            }
        }
    }
}
