﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;
using System.Numerics;

namespace katzerle
{
    class RarekillerInteractNPC
    {
        public static LocalPlayer Me = StyxWoW.Me;
        private static Stopwatch BlacklistTimer = new Stopwatch();

        public static Vector3 ProblemCamel1 = new Vector3(-8906.634f, 312.6967f, 349.2024f);
        public static Vector3 ProblemCamel2 = new Vector3(-9900.116f, 461.3653f, 45.62226f);
        public static Vector3 ProblemCamel3 = new Vector3(-10697.69f, 1045.757f, 24.125f);
        public static Vector3 ProblemCamel4 = new Vector3(-11066.67f, -2100.342f, 175.2816f);
        public static Vector3 LandingPoint64227 = new Vector3(2359.229f, 2484.88f, 686.5128f);

        /// <summary>
        /// returns the WoWUnit to interact with
        /// </summary>
        public WoWUnit InteractableNPC
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => !Blacklist.Contains(o.Guid, Rarekiller.Settings.Flags) && (
                    (Rarekiller.InteractNPCList.ContainsKey(Convert.ToInt32(o.Entry)) && Rarekiller.Settings.InteractNPC)
                ))
                .OrderBy(o => o.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// Function to Find and Interact with NPCs
        /// </summary>
        public void findAndInteractNPC(WoWUnit InteractNPC)
        {
            List<WoWUnit> RareList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(r => ((r.CreatureRank == Styx.WoWUnitClassificationType.Rare) && r.Level > 85 && !r.IsDead)).OrderBy(r => r.Distance).ToList();

            bool Forceground = false;

            Logging.WriteQuiet(Colors.MediumPurple, "Rarekiller: Find NPC {0} ID {1}", InteractNPC.Name, InteractNPC.Entry);
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: NPC Location: {0} / {1} / {2}", Convert.ToString(InteractNPC.X), Convert.ToString(InteractNPC.Y), Convert.ToString(InteractNPC.Z));
            if (Rarekiller.Settings.LUAoutput)
                Lua.DoString("print('NPCScan: Find {0} ID {1}')", InteractNPC.Name, InteractNPC.Entry);

            if (Rarekiller.Settings.Alert)
                Rarekiller.Alert();

            //if not ID of Underground NPCs of Another Mans Treasure --> don't collect
            if (!(InteractNPC.Entry == 64227))
            {
                if (InteractNPC.IsIndoors && Me.IsFlying && Me.IsOutdoors && (InteractNPC.Location.Distance(Me.Location) > 30))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Can't reach NPC because it is Indoors and I fly Outdoors {0}, Blacklist and Move on", InteractNPC.Name);
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC is Indoors')", InteractNPC.Name);
                    Blacklist.Add(InteractNPC.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    return;
                }
            }

            if (Rarekiller.DontInteract) return;

            // Move to helper point if figurine is under a tent
            if (Me.IsFlying && ((InteractNPC.Location.Distance(ProblemCamel1) < 10) || (InteractNPC.Location.Distance(ProblemCamel2) < 10) ||
                    (InteractNPC.Location.Distance(ProblemCamel3) < 10) || (InteractNPC.Location.Distance(ProblemCamel4) < 20)))
            {
                Vector3 HelperPointCamel = InteractNPC.Location;
                HelperPointCamel.X = HelperPointCamel.X + 20;
                HelperPointCamel.Z = HelperPointCamel.Z + 5;
                Logging.Write(Colors.MediumPurple, "Rarekiller: Found a Problem Figurine {0} so dismount and walk", InteractNPC.Entry);
                if (!Rarekiller.MoveTo(HelperPointCamel, 3, false)) return;
                //if (!Rarekiller.DescendToLand(o)) return;
                Rarekiller.Dismount();
                Forceground = true;
            }

            //  Move to Helperpoint if known Underground NPC
            if (Me.IsFlying && InteractNPC.Entry == 64227)
            {
                if (!Rarekiller.MoveTo(LandingPoint64227, 5, false)) return;
                Rarekiller.Dismount();
                Forceground = true;
            }

            //  Move to NPC
            if (Me.IsFlying && Forceground)
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: Failure in Programming. Fly again to Helperpoint and Dismount", InteractNPC.Entry);
                return;
            }
            if (!Rarekiller.MoveTo(InteractNPC, 4, Forceground)) return;
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: NPC Location: {0} / {1} / {2}", Convert.ToString(InteractNPC.X), Convert.ToString(InteractNPC.Y), Convert.ToString(InteractNPC.Z));
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: My Location: {0} / {1} / {2}", Convert.ToString(Me.X), Convert.ToString(Me.Y), Convert.ToString(Me.Z));
            Rarekiller.Dismount();

            InteractNPC.Interact();
            InteractNPC.Interact();
            InteractNPC.Interact();

            Logging.Write(Colors.MediumPurple, "Rarekiller: Interact with NPC - ID {0}", InteractNPC.Entry);
            Thread.Sleep(300);
        }
    }
}
