﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot.Routines;
using Styx.Pathing;

namespace katzerle
{
    class RarekillerKiller
    {

        public static LocalPlayer Me = StyxWoW.Me;
        private static Stopwatch WaitAfterPullTimer = new Stopwatch();

        /// <summary>
        /// returns the WoWUnit to kill
        /// </summary>
        public WoWUnit killableEnemy
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => (
                    !Blacklist.Contains(o.Guid, Rarekiller.Settings.Flags) 
                    && !o.IsPet 
                    && (
                    (Rarekiller.Settings.KillList && (Rarekiller.KillMobsList.ContainsKey(Convert.ToInt32(o.Entry)))) //Kill Mobs from List
                    || (Rarekiller.Settings.HUNTbyID && (o.Entry == Convert.ToInt64(Rarekiller.Settings.MobID)))                // Hunt special IDs 
                    )))
                    .OrderBy(o => o.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// Function to Find and Kill Mobs
        /// </summary>
        public void findAndKillMob(WoWUnit Enemy)
        {
            bool CastSuccess = false;

            if (!Enemy.IsDead)
            {
                // Check if tameable 
                if (Rarekiller.Settings.NotKillTameable && Enemy.IsTameable) 
                {
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Find a hunted Mob called {0} ID {1}, but kill tameable", Enemy.Name, Enemy.Entry);
                    return;
                }

                Logging.WriteQuiet(Colors.MediumPurple, "Rarekiller: Find a hunted Mob called {0} ID {1}", Enemy.Name, Enemy.Entry);
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Mob Location: {0} / {1} / {2}", Convert.ToString(Enemy.X), Convert.ToString(Enemy.Y), Convert.ToString(Enemy.Z));
                if (Rarekiller.Settings.LUAoutput)
                    Lua.DoString("print('NPCScan: Find {0} ID {1}')", Enemy.Name, Enemy.Entry);

                // Don't kill if
                // ... reached max pull counter
                if (Rarekiller.Settings.PullCounter >= Rarekiller.Settings.MaxPullCounter)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Find {0}, but I pulled him now {1} Times", Enemy.Name, Rarekiller.Settings.PullCounter);
                    Blacklist.Add(Enemy.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: I pulled now {0} times, blacklist')", Rarekiller.Settings.PullCounter);
                    Rarekiller.Settings.PullCounter = 0;
                    Rarekiller.Settings.GuidCurrentPull = 0;
                    Rarekiller.Settings.BlacklistCounter++;
                    return;
                }
                
                // ... is tagged by others and kill tagged mobs is not checked 
                if (Enemy.TaggedByOther && !Rarekiller.Settings.KillTagged)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Find {0}, but he's tagged by another Player", Enemy.Name);
                    Blacklist.Add(Enemy.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC is tagged')", Enemy.Name);
                    return;
                }

                // ... is Friendly
                if (Enemy.IsFriendly) 
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Find {0}, but he's friendly", Enemy.Name);
                    Blacklist.Add(Enemy.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC is friendly')", Enemy.Name);
                    return;
                }

                // ... Mob is Blacklisted in Rarekiller/config/BlacklistedMobs.xml
                if(Rarekiller.BlacklistMobsList.ContainsKey(Convert.ToInt32(Enemy.Entry)))              
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: {0} is Member of the BlacklistedMobs.xml", Enemy.Name);
                    Blacklist.Add(Enemy.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    return;
                }

                if (Rarekiller.DontInteract) return;

                // Alert
                if (Rarekiller.Settings.Alert)
                    Rarekiller.Alert();
                
                // Get spell to use
                string UsableSpell = string.Empty;
                if (!Rarekiller.Settings.DefaultPull && SpellManager.HasSpell(Rarekiller.Settings.Pull))
                {
                    UsableSpell = Rarekiller.Settings.Pull;
                }
                else
                {
                    UsableSpell = Rarekiller.Spells.DefaultPullspell;
                }
                Logging.Write(Colors.MediumPurple, "Rarekiller: Set Pull Spell to {0}", UsableSpell);

                // Check pull range 
                string UsedPullRange = "20";
                if (Rarekiller.Settings.ForceRange)
                {
                    UsedPullRange = Rarekiller.Settings.Range;
                }
                else
                {
                    UsedPullRange = Rarekiller.Spells.RangeCheck(UsableSpell);
                }
                Logging.Write(Colors.MediumPurple, "Rarekiller: Set Pull Range to {0}", UsedPullRange);

                // Move to mob
                if (!Rarekiller.MoveTo(Enemy, Convert.ToInt64(UsedPullRange), false)) return;

                // Pull mob
                Logging.Write(Colors.MediumPurple, "Rarekiller: Pull at Mob Location: {0} / {1} / {2}", Convert.ToString(Enemy.X), Convert.ToString(Enemy.Y), Convert.ToString(Enemy.Z));
                Logging.Write(Colors.MediumPurple, "Rarekiller: My current Location: {0} / {1} / {2}", Convert.ToString(Me.X), Convert.ToString(Me.Y), Convert.ToString(Me.Z));

                Enemy.Target();

                if (SpellManager.HasSpell(UsableSpell))
                {

                    CastSuccess = RarekillerSpells.CastSafe(UsableSpell, Enemy, true);
                }
                else
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: I have no valid Pullspell - sorry");
                }

                if (Me.CurrentTarget != Enemy)
                    Enemy.Target();

                // Pull timer and pull counter
                WaitAfterPullTimer.Reset();
                WaitAfterPullTimer.Start();
                while (WaitAfterPullTimer.IsRunning && !Rarekiller.ToonInvalidCombat && WaitAfterPullTimer.ElapsedMilliseconds < 2000)
                {
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Wait for Combat now {0} ms", WaitAfterPullTimer.ElapsedMilliseconds);
                    Thread.Sleep(100);
                }

                if (CastSuccess && Me.Combat)
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Successfully pulled {0}", Enemy.Name);
          
                return;                 
            }
            else
            {             
                if (Enemy.CanLoot)
                    if(!Rarekiller.Loothelper(Enemy)) return;
                        
                if (!Blacklist.Contains(Enemy.Guid, Rarekiller.Settings.Flags))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Find {0}, but sadly he's dead", Enemy.Name);
                    Blacklist.Add(Enemy.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                }
            }
        }
    }
}
