﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//                and all the brave Testers
//
//==================================================================

// -- ToDo Prio 1 --
// Extra GUI für Tamer
// Aeonaxx Catcher testen
// Liste vom ObjectGatherer übernehmen mit GUI
// -- ToDo Prio 2 --
// Huolon (Timeless Isles) wegen Mount
// Neue Rare von Vale of Eternal Blossom
// Hunter Pets Pandaria (Footprints)
// Erfolgspunkte abchecken

using System;
using System.Collections.Generic;
using System.Threading;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.Windows.Forms;
using System.Net;
using System.Globalization;
using System.Windows.Media;
using System.Media;
using System.Linq;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.Pathing;
using Styx.WoWInternals.World;
using System.Numerics;

namespace katzerle
{
    class Rarekiller: HBPlugin
    {
        //Variables
        public static string name { get { return "Rarekiller"; } }
        public override string Name { get { return name; } }
        public override string Author { get { return "katzerle"; } }
        private readonly static Version _version = new Version(5, 0);
        public override Version Version { get { return _version; } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        
        public static LocalPlayer Me = StyxWoW.Me;
        public static RarekillerSettings Settings = new RarekillerSettings();
        public static RarekillerKiller Killer = new RarekillerKiller();
        public static RarekillerInteractNPC InteractNPC = new RarekillerInteractNPC();
        public static RarekillerCamel Camel = new RarekillerCamel();
        public static RarekillerTamer Tamer = new RarekillerTamer();
        public static RarekillerCollector Collector = new RarekillerCollector();
        public static RarekillerSecurity Security = new RarekillerSecurity();
        public static RarekillerSpells Spells = new RarekillerSpells();
        public static RarekillerAeonaxx AeonaxxCatcher = new RarekillerAeonaxx();
        public static RarekillerVoidtalon Voidtalon = new RarekillerVoidtalon();

        private static Stopwatch Checktimer = new Stopwatch();

        public static Dictionary<Int32, string> BlacklistMobsList = new Dictionary<Int32, string>();
        public static Dictionary<Int32, string> TameableMobsList = new Dictionary<Int32, string>();
        public static Dictionary<Int32, string> CollectObjectsList = new Dictionary<Int32, string>();
        public static Dictionary<Int32, string> KillMobsList = new Dictionary<Int32, string>();
        public static Dictionary<Int32, string> InteractNPCList = new Dictionary<Int32, string>();
        
        public static bool hasItBeenInitialized = false; 
        Int32 MoveTimer = 400;
        public static Random rnd = new Random();
        
        public Rarekiller()
        {
            Logging.WriteQuiet(Colors.MediumPurple, "Rarekiller 5 BETA loaded");
            Lua.Events.AttachEvent("CHAT_MSG_BN_WHISPER", Security.BNWhisper);
            Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", Rarekiller.AcceptLFG);

            if (Me.Class != WoWClass.Hunter)
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: I'm no Hunter. Deactivate the Tamer Part");
                Settings.TameByID = false;
                Settings.TameList = false;

                Settings.TameMobID = "";
                Settings.Hunteractivated = false;
            }
        }

        static private void BotStopped(EventArgs args)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Had to Blacklist {0} permanently", Settings.BlacklistCounter);

            // Alerts for Wisper and Guild
            Chat.Whisper -= Security.newWhisper;       
            Chat.Guild -= Security.newGuild;
            Chat.Officer -= Security.newOfficer;
                        
            // Register the events of the Start/Stop Button in HB
            BotEvents.OnBotStopped -= BotStopped;
            // Clear some Lists
            BlacklistMobsList.Clear();
            TameableMobsList.Clear();
            CollectObjectsList.Clear();
            KillMobsList.Clear();
            InteractNPCList.Clear();
            hasItBeenInitialized = false;
        }
        
        public override void OnButtonPress()
        {
            ConfigForm.ShowDialog();
        }

        private Form MyForm;
        public Form ConfigForm
        {
            get
            {
                if(MyForm == null)
                    MyForm = new RarekillerUI();
                return MyForm;
            }
        }
        
        /// <summary>
        /// Initialize - Do this once at first Pulse
        /// </summary>
        static public void Initialize()
        {
            // Register the events of the Start/Stop Button in HB
            BotEvents.OnBotStopped += BotStopped;

            // ------------ Deactivate RareAlerter if Rarekiller is Enabled         
            List<PluginContainer> _pluginList = PluginManager.Plugins;
            foreach (PluginContainer _plugin in _pluginList)
            {
                if (_plugin.Enabled && _plugin.Plugin.Name == "RareAlerter")
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: RareAlerter deactivated");
                    _plugin.Enabled = false;
                }
            }

            //Alerts for Wisper and Guild
            Chat.Whisper += Security.newWhisper;
            Chat.Guild += Security.newGuild;
            Chat.Officer += Security.newOfficer;

            string sPath1 = Path.Combine(FolderPath, "config\\BlacklistedMobs.xml");
            FillDictionaryFromFile(BlacklistMobsList, sPath1);

            string sPath2 = Path.Combine(FolderPath, "config\\TameableMobs.xml");
            FillDictionaryFromFile(TameableMobsList, sPath2);

            string sPath3 = Path.Combine(FolderPath, "config\\CollectObjects.xml");
            FillDictionaryFromFile(CollectObjectsList, sPath3);

            string sPath4 = Path.Combine(FolderPath, "config\\KillMobs.xml");
            FillDictionaryFromFile(KillMobsList, sPath4);

            string sPath5 = Path.Combine(FolderPath, "config\\InteractNPC.xml");
            FillDictionaryFromFile(InteractNPCList, sPath5);
        }

        public override void Pulse()
        {
            try
            {
                ObjectManager.Update();

                if (Rarekiller.ToonInvalid) return;

                // Init
                if (!hasItBeenInitialized)
                {
                    Initialize();
                    hasItBeenInitialized = true;
                }

                // Timer
                if (Settings.Keyer && !Checktimer.IsRunning && !Me.IsMoving)
                    Checktimer.Start();
                if (Settings.Keyer && Checktimer.IsRunning && Me.IsMoving)
                    Checktimer.Reset();

                // Aeonaxx Catcher
                if (Settings.Aeonaxx)
                {
                    if (AeonaxxCatcher.AeonaxxFriendly != null || AeonaxxCatcher.AeonaxxHostile != null)
                    {
                        AeonaxxCatcher.catchAeonaxx();
                        return;                       
                    }                   
                }

                if (!Me.Combat)
                {                    
                    // Camel Figurines
                    if (Settings.Camel)
                    {
                        if (Camel.FakeCamelFigurine != null)
                            InteractNPC.findAndInteractNPC(Camel.FakeCamelFigurine);
                        if (Camel.RealCamelFigurine != null)
                            InteractNPC.findAndInteractNPC(Camel.RealCamelFigurine);
                        if (Me.HasAura(93269) || Camel.Dormus != null)
                            Camel.findAndKillDormus();
                    }

                    // Voidtalon
                    if (Settings.Voidtalon)
                    {
                        if (Voidtalon.EdgeOfReality != null)
                            Collector.findAndPickupObject(Voidtalon.EdgeOfReality);
                        if (Voidtalon.VoidtalonEgg != null)
                            Collector.findAndPickupObject(Voidtalon.VoidtalonEgg);
                    }

                    // Object Collector
                    if (Collector.InteractableObject != null)
                        Collector.findAndPickupObject(Collector.InteractableObject);

                    // NPC Interact
                    if (InteractNPC.InteractableNPC != null)
                        InteractNPC.findAndInteractNPC(InteractNPC.InteractableNPC);

                    // Tamer
                    if (Me.Class == WoWClass.Hunter && Tamer.tameablePet != null)
                    {
                        if (Me.HealthPercent > 30)
                            Tamer.findAndTameMob(Tamer.tameablePet);
                    }

                    // Find and hunt mob
                    if (Killer.killableEnemy != null)
                        Killer.findAndKillMob(Killer.killableEnemy);

                    // Anti AFK
                    if (Settings.Keyer && !Me.IsMoving)
                    {
                        if (Checktimer.Elapsed.TotalSeconds > MoveTimer)
                        {
                            Checktimer.Reset();
                            MoveTimer = rnd.Next(360, 840);
                            Security.Movearound();
                        }
                    }
                }
            }
            
            catch (ThreadAbortException) { }
            catch (Exception e)
            {
                Logging.WriteDiagnostic(Colors.Red, e.Message);
            }
        }

        #region Misc Helper Functions
        /// <summary>
        /// Returns the Default Soundfile
        /// </summary>
        static public string Soundfile
        {
            get
            {
                string sPath = Path.Combine(Rarekiller.FolderPath, "Sounds\\siren.wav");
                return sPath;
            }
        }

        /// <summary>
        /// Returns another Default Soundfile
        /// </summary>
        static public string Soundfile2
        {
            get
            {
                string sPath = Path.Combine(Rarekiller.FolderPath, "Sounds\\attention.wav");
                return sPath;
            }
        }

        /// <summary>
        /// Returns the Folder of Rarekiller
        /// </summary>
        static public string FolderPath
        {
            get
            {
                string sPath = Process.GetCurrentProcess().MainModule.FileName;
                sPath = Path.GetDirectoryName(sPath);
                sPath = Path.Combine(sPath, "Plugins\\Rarekiller\\");
                return sPath;
            }
        }

        /// <summary>
        /// Returns the Honorbuddy Settings Folder
        /// </summary>
        static public string SettingsPath
        {
            get
            {
                string sPath = Process.GetCurrentProcess().MainModule.FileName;
                sPath = Path.GetDirectoryName(sPath);
                sPath = Path.Combine(sPath, "Settings\\");
                return sPath;
            }
        }

        /// <summary>
        /// Alert Function
        /// </summary>
        static public void Alert()
        {
            if(Rarekiller.Settings.Alert)
            {
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Make Noise");
                if (File.Exists(Rarekiller.Settings.SoundfileFoundRare))
                    new SoundPlayer(Rarekiller.Settings.SoundfileFoundRare).Play();
                else if (File.Exists(Rarekiller.Soundfile))
                    new SoundPlayer(Rarekiller.Soundfile).Play();
                else
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: playing Soundfile failes");
            }
        }

        /// <summary>
        /// returns true Me is in Combat or Transport and puts into Logfile
        /// </summary>
        static public bool DontInteract
        {
            get
            {
                if (Me.Combat)
                {
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: ... but first I have to finish fighting another Unit.");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: First finish combat')");
                    return true;
                }
                if (Me.IsOnTransport)
                {
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: ... but I'm on a Transport.");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: I'm on Transport')");
                    return true;
                }
                return false;
            }
        }

        /// <summary>
        /// Loots a Lootable Unit
        /// </summary>
        static public bool Loothelper(WoWUnit o)
        {
            if (o.Lootable)
            {
                int loothelper = 0;
                Logging.Write(Colors.MediumPurple, "Rarekiller: Found lootable corpse, move to him");
                if (o.Entry == 50245) Dismount();
                if (o.Entry == 49822 || o.Entry == 50245 || o.IsIndoors)
                {if (!MoveTo(o.Location, 5, true)) return false;}
                else
                {if (!MoveTo(o.Location, 5, false)) return false;}
                if (o.Entry != 50245) Dismount();

                while (loothelper < 3)
                {
                    WoWMovement.MoveStop();
                    o.Interact();
                    Thread.Sleep(1000);
                    Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
                    Thread.Sleep(1000);
                    if (!o.CanLoot)
                    {
                        Logging.Write(Colors.MediumPurple, "Rarekiller: successfully looted");
                        Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                        Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                        return true;
                    }
                    else
                    {
                        Logging.Write(Colors.MediumPurple, "Rarekiller: Loot failed, try again");
                        loothelper = loothelper + 1;
                    }

                }
                Logging.Write(Colors.MediumPurple, "Rarekiller: Loot failed 3 Times");
                Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                return false;
            }
            return true;
        }

               /// <summary>
        /// Credits to exemplar.
        /// </summary>
        /// <returns>Z-Coordinates for PoolPoints so we don't jump into the water.</returns>
        static public float getGroundZ(Vector3 p)
        {
            Vector3 ground = Vector3.Zero;

            GameWorld.TraceLine(new Vector3(p.X, p.Y, (p.Z + 100)), new Vector3(p.X, p.Y, (p.Z - 5)), TraceLineHitFlags.EntityCollision/*GameWorld.TraceLineHitFlags.EntityCollision | GameWorld.CGWorldFrameHitFlags.HitTestBoundingModels | GameWorld.CGWorldFrameHitFlags.HitTestWMO*/, out ground);

            if (ground != Vector3.Zero)
            {
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Ground Z: {0}.", ground.Z);
                return ground.Z;
            }
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Ground Z returned float.MinValue.");
            return float.MinValue;
        }

        /// <summary>
        /// Loads the Config Files
        /// </summary>
        static public void FillDictionaryFromFile(Dictionary<Int32, string> Dictionary, string sPath)
        {
            XmlDocument XMLDokument = new XmlDocument();
            Logging.Write(Colors.MediumPurple, "Rarekiller: Load {0}", sPath);
            if (File.Exists(sPath))
            {
                System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.ReadWrite);
                try
                {
                    XMLDokument.Load(fs);
                    fs.Close();
                }
                catch (Exception e)
                {
                    Logging.WriteDiagnostic(Colors.Red, e.Message);
                    fs.Close();
                    return;
                }
                XmlElement root = XMLDokument.DocumentElement;
                foreach (XmlNode Node in root.ChildNodes)
                {
                    Int32 Entry = Convert.ToInt32(Node.Attributes["Entry"].InnerText);
                    string Name = Node.Attributes["Name"].InnerText;
                    Dictionary.Add(Entry, Name);
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Add to List - Name: {0} Entry: {1}", Name, Entry);
                }
                Logging.Write(Colors.MediumPurple, "Rarekiller: transfered {0} Elements", Dictionary.Count);
            }
            else
            {
                Dictionary.Add(99999999, "DummyMob");
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: File {0} doesn't exist", sPath);
            }
            Logging.Write(Colors.MediumPurple, "-------------------------------------");
        }
        #endregion

        #region Movement Functions
        /// <summary>
        /// Descend Function
        /// </summary>
        static public bool DescendToLand(WoWUnit Unit)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Descend to Land");
            Vector3 Ground = Me.Location;
            Ground.Z = getGroundZ(Me.Location);
            if (Ground.Z != float.MinValue)
            {
                while (Me.Location.Distance(Ground) > 5)
                {
                    Flightor.MoveTo(Ground);
                    Thread.Sleep(200);
                    if (Rarekiller.ToonInvalidCombat) return false;
                }
            }
            else
            {
                Vector3 Groundnear = Me.Location;
                Groundnear.Z = Unit.Z + 5;
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Move Groundnear, because getGroundZ returns float.MinValue");
                while (Me.Location.Distance(Groundnear) > 3 && Me.IsFlying)
                {
                    Flightor.MoveTo(Groundnear);
                    Thread.Sleep(200);
                    if (Rarekiller.ToonInvalidCombat) return false;
                }
            }
            return true;
        }

        /// <summary>
        /// Dismount Function
        /// </summary>
        static public void Dismount()
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Dismount");
            //Dismount
            WoWMovement.MoveStop();
            if (Me.Auras.ContainsKey("Flight Form"))
                Lua.DoString("CancelShapeshiftForm()");
            else if (Me.Mounted)
                Lua.DoString("Dismount()");
            Thread.Sleep(500);
        }

        /// <summary>
        /// Moves to a Unit
        /// </summary>
        static public bool MoveTo(WoWUnit o, Int64 Distance, bool Forceground)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Move to {0}", o.Name);
            Stopwatch BlacklistTimer = new Stopwatch();
            BlacklistTimer.Start();
            while ((o.Location.Distance(Me.Location) > Distance) && !o.IsDead)
            {
                if ((o.Entry == 49822 || Me.IsIndoors || Forceground) && Me.IsSwimming)
                    WoWMovement.ClickToMove(o.Location);
                else if (o.Entry == 49822 || Me.IsIndoors || Forceground)
                    Navigator.MoveTo(o.Location);
                else
                    Flightor.MoveTo(o.Location);
                Thread.Sleep(200);

                if (Rarekiller.ToonInvalidCombat) return false; 
                if (o.TaggedByOther && !Settings.KillTagged)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Unit {0} is tagged by another Player", o.Name);
                    Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC {0} is tagged')", o.Name);
                    BlacklistTimer.Reset();
                    WoWMovement.MoveStop();
                    return false;
                }

                // ----------------- Security  ---------------------
                if (BlacklistTimer.Elapsed.TotalSeconds > (Convert.ToInt32(Rarekiller.Settings.BlacklistTime)))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Can't reach Unit {0}, Blacklist and Move on", o.Name);
                    Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    BlacklistTimer.Reset();
                    WoWMovement.MoveStop();
                    return false;
                }
            }
            BlacklistTimer.Reset();
            WoWMovement.MoveStop();
            if (o.IsDead && !o.CanLoot)
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: Unit was killed by another Player");
                Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                return false;
            }
            return true;
        }

        /// <summary>
        /// Moves to a Unit
        /// </summary>
        static public bool MoveTo(WoWObject o, Int64 Distance, bool ForceGround)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Move to {0}", o.Name);
            Stopwatch BlacklistTimer = new Stopwatch();
            BlacklistTimer.Start();

            while (o.Location.Distance(Me.Location) > Distance)
            {
                if (ForceGround && Me.IsSwimming)
                    WoWMovement.ClickToMove(o.Location);
                else if (ForceGround)
                    Navigator.MoveTo(o.Location);
                else
                    Flightor.MoveTo(o.Location);
                Thread.Sleep(200);
                // ----------------- Security  ---------------------
                if (Rarekiller.ToonInvalidCombat) return false;
                if (BlacklistTimer.Elapsed.TotalSeconds > (Convert.ToInt32(Rarekiller.Settings.BlacklistTime)))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Can't reach Object {0}, Blacklist and Move on", o.Name);
                    Blacklist.Add(o.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    BlacklistTimer.Reset();
                    WoWMovement.MoveStop();
                    return false;
                }
            }
            BlacklistTimer.Reset();
            Thread.Sleep(300);
            WoWMovement.MoveStop();
            return true;
        }

        /// <summary>
        /// Fly to a Helperpoint for a special Unit
        /// </summary>
        static public bool MoveTo(Vector3 Helperpoint, WoWUnit o, Int64 Distance, bool ForceGround)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Move to Helperpoint for {0}", o.Name);
            while (Me.Location.Distance(Helperpoint) > Distance)
            {
                if (ForceGround && Me.IsSwimming)
                    WoWMovement.ClickToMove(Helperpoint);
                else if (ForceGround)
                    Navigator.MoveTo(Helperpoint);
                else
                    Flightor.MoveTo(Helperpoint);
                Thread.Sleep(200);
                if (Rarekiller.ToonInvalidCombat) return false;
                if (o.TaggedByOther && !Settings.KillTagged)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Unit {0} is tagged by another Player", o.Name);
                    Blacklist.Add(Me.CurrentTarget.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC {0} is tagged')", o.Name);
                    WoWMovement.MoveStop();
                    return false;
                }
            }
            return true;
        }

        /// <summary>
        /// Fly to a Helperpoint
        /// </summary>
        static public bool MoveTo(Vector3 Helperpoint, Int64 Distance, bool ForceGround)
        {
            Logging.Write(Colors.MediumPurple, "Rarekiller: Move to Helperpoint");
            while (Me.Location.Distance(Helperpoint) > Distance)
            {
                if (ForceGround && Me.IsSwimming)
                    WoWMovement.ClickToMove(Helperpoint);
                else if (ForceGround)
                    Navigator.MoveTo(Helperpoint);
                else
                    Flightor.MoveTo(Helperpoint);
                Thread.Sleep(200);
                if (Rarekiller.ToonInvalidCombat) return false;
            }
            return true;
        }
        #endregion

        /// <summary>
        /// returns true if Game crashed, Relogwindow appears, the Toon is in Combat or Petbattle or Dead or Ghost etc
        /// </summary>
        static public bool ToonInvalidCombat
        {
            get
            {
                if (Me == null || !StyxWoW.IsInGame || Me.Combat || Me.IsDead || Me.IsGhost || InPetCombat()) return true;
                return false;
            }
        }

        /// <summary>
        /// returns true if Game crashed, Relogwindow appears, the Toon is in Combat or Petbattle or Dead or Ghost etc
        /// </summary>
        static public bool ToonInvalid
        {
            get
            {
                if (Me == null || !StyxWoW.IsInGame || Me.IsDead || Me.IsGhost || InPetCombat()) return true;
                return false;
            }
        }

        /// <summary>
        /// returns true Petbattle
        /// </summary>
        static public bool InPetCombat()
        {
            List<string> cnt = Lua.GetReturnValues("dummy,reason=C_PetBattles.IsTrapAvailable() return dummy,reason");
            if (cnt != null) { if (cnt[1] != "0") return true; }
            return false;
        }

        static public void AcceptLFG(object sender, LuaEventArgs args)
        {
            if (Settings.Voidtalon)
            {
                Logging.Write("[Voidtalon]: LFG menu detected, accepting between 3-6 seconds");
                Random r = new Random();
                Thread.Sleep(r.Next(3, 6) * 1000);
                Lua.DoString("AcceptProposal()");
            }
        }
    }
}
